/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <amxmisc>
#include <nvault>

#define PLUGIN "User-Tag Prefix"
#define VERSION "2.2"
#define AUTHOR "Natsheh"

#define TASK_LOGIN_BYPASS 12000

enum
{
	BYIP = 0,
	BYSTEAM,
	BYNAME,
	BYFLAG,
	BYPASS
}

new const tag_stats[][] = {
	"IP",
	"STEAM",
	"NAME",
	"FLAG",
	"PASS"
}

new const TAG_FILE_NAME[] = "users_tag.cfg"

enum 
{ 
	Udead = 0,
	Ualive 
}

new nVLT

new user_prefix[33][34]
new g_user_prefix[33]
new clogintag[33][34]
new players[32], pnum
new bool:user_show_password[33]

new const stats_prefix[][] = { 
	"*DEAD*", 
	"*ALIVE*"
}

new const team_prefix[][] = {
	"(Spectator)",
	"(Terrorist)",
	"(Counter-Terrorist)",
	"(Spectator)"
}

new g_show_stats, g_cvar_pw, g_maxplayers;

new Array:Multitag[33]

public plugin_cfg()
{
	nVLT = nvault_open("UTP_CLTag")
	
	if(nVLT == INVALID_HANDLE)
	{
		set_fail_state("Error opening nVault ( UTP_CLTag )")
	}
}

public plugin_end()
{
	nvault_close(nVLT)
	
	for(new i = 1; i <= g_maxplayers; i++)
	{
		if(Multitag[i] > Array:0) ArrayDestroy(Multitag[i]);
	}
}

public plugin_natives()
{
	for(new i = 1; i <= (g_maxplayers = get_maxplayers()); i++)
	{
		Multitag[i] = ArrayCreate(34, 1)
	}
}

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	g_show_stats = register_cvar("utp_show_user_status", "1")
	g_cvar_pw = register_cvar("utp_login_info", "_tag")
	
	register_clcmd("amx_tag_password", "user_entered_password", -1, "Open the login menu for pass method!")
	
	register_message(get_user_msgid("SayText"), "user_cmd_saytext")
	
	register_concmd("amx_reloadtags", "cmd_reload_tags", ADMIN_IMMUNITY, "reload the tag config!")
	register_concmd("amx_addtag", "cmd_add_tag", ADMIN_IMMUNITY, "<ip/steam/name/flag> <u-ip/u-steam/u-name/none> <flag> <tag> <cchat(!t/!y/!g)> <pass>")
	register_clcmd("amx_removetagmenu", "cmd_remove_tagmenu", ADMIN_IMMUNITY, "Show Tag Menu which you can remove tags from it")
	register_clcmd("amx_changetagmenu", "cmd_change_tagmenu", -1, "Change user tag-prefix to any available tag for the user")
}

public load_user_last_tag(id, sTag[], len)
{
	new uSteamid[32], proccess, uLTag[34]
	get_user_authid(id, uSteamid, charsmax(uSteamid))
	proccess = nvault_get(nVLT, uSteamid, uLTag, charsmax(uLTag))
	copy(sTag, len, uLTag)
	return proccess
}

public save_user_last_tag(id)
{
	new uSteamid[32]
	get_user_authid(id, uSteamid, charsmax(uSteamid))
	nvault_set(nVLT, uSteamid, user_prefix[id])
}

public client_putinserver(id)
{
	if(!is_user_bot(id))
	{
		remove_tag(id)
		check_user_tag(id)
	}
}

public client_disconnect(id)
{
	if(!is_user_bot(id))
	{
		remove_tag(id)
	}
}

public client_infochanged(id)
{
	new newname[32], oldname[32]
	get_user_name(id, oldname, charsmax(oldname))
	get_user_info(id, "name", newname, charsmax(newname))
	
	if(!equal(oldname, newname))
	{
		remove_tag(id)
		check_user_tag(id)
	}
}

public user_cmd_saytext(msgid, msgdest, entity_id)
{
	new id = get_msg_arg_int(1)
	
	if(equal(user_prefix[id], "DISABLED254358") || !g_user_prefix[id] || !is_user_connected(entity_id) || !is_user_connected(id)) return 0
	
	new sBuffer[256], szArgs[192], szChannel[24], szStats[8]
	
	new g_stats = get_pcvar_num(g_show_stats)
	new is_alive = is_user_alive(id)
	formatex(szStats, charsmax(szStats), "%s", (!g_stats ? stats_prefix[is_alive]:(g_stats == 1) ? (is_alive ? "^0":stats_prefix[Udead]):(is_alive ? stats_prefix[Ualive]:"^0")))
	
	get_msg_arg_string(4, szArgs, charsmax(szArgs))
	get_msg_arg_string(2, szChannel, charsmax(szChannel))
	
	new i = strlen(user_prefix[id]), iColor[3];
	formatex(iColor, charsmax(iColor), "%c%c", user_prefix[id][i-2], user_prefix[id][i-1])
	
	new user_name[32]
	get_user_name(id, user_name, charsmax(user_name))
	
	new prefix[32];
	formatex(prefix, charsmax(prefix), user_prefix[id])
	
	if(equal(szChannel, "#Cstrike_Chat_All", 16))
	{
		formatex(sBuffer, charsmax(sBuffer), "%s%c%s %c%s %c: %s%s", szStats, '^4', prefix,
		'^3', user_name, '^4', iColor, szArgs)
	}
	else
	{
		formatex(sBuffer, charsmax(sBuffer), "%s%c%s %c%s %c%s %c: %s%s", szStats, '^3', team_prefix[get_user_team(id)],
		'^4', prefix, '^3', user_name, '^4', iColor, szArgs)
	}
	
	chat_message(MSG_ONE, entity_id, id, sBuffer)
	return 1
}

public cmd_reload_tags(id, level, cid)
{
	if(!cmd_access(id, level, cid, 1))
		return 1
	
	remove_users_tags()
	tag_file()
	console_print(id, "Tag File Has Been Successful reloaded!")
	log_amx("Tag File Has Been Successful reloaded!")
	return 1
}

public cmd_add_tag(id, level, cid)
{
	if(!cmd_access(id, level, cid, 4))
		return 1
	
	new sState[16], sID[32], zFlag[22], sTag[32], sPass[32], sCColor[4];
	
	new bool:sCorrect, bool:fCorrect
	
	read_argv(1, sState, charsmax(sState))
	read_argv(2, sID, charsmax(sID))
	read_argv(3, zFlag, charsmax(zFlag))
	read_argv(4, sTag, charsmax(sTag))
	read_argv(5, sCColor, charsmax(sCColor))
	read_argv(6, sPass, charsmax(sPass))
	
	trim(sCColor)
	remove_quotes(sCColor)
	
	if(!strlen(sCColor) || (!equal(sCColor, "!y") && !equal(sCColor, "!g") && !equal(sCColor, "!t") && !equal(sCColor, "!n")))
	{
		formatex(sCColor, charsmax(sCColor), "!y")
	}
	
	if(strlen(sTag) < 3)
	{
		console_print(id, "Process failed the tag you have just entered is too short!")
		return 1
	}
	
	for(new x = 0; x < sizeof tag_stats; x++)
	{
		if(equali(sState, tag_stats[x]))
		{
			sCorrect = true
			break;
		}
	}
	
	for(new x = 0; x < strlen(zFlag); x++)
	{
		if(!isalpha(zFlag[x]))
		{
			fCorrect = true
			break;
		}
	}
	
	if(!sCorrect || fCorrect)
	{
		console_print(id, "Error:- login-method: %s (ip/steam/name/flag/pass)| Flags: %s (alphabet only)", sCorrect ? "Correct":"False", !fCorrect ? "Correct":"False")
		return 1
	}
	
	new user_connected
	
	if(equali(sState, tag_stats[BYIP]))
	{
		user_connected = is_user_exists_byip(sID)
	}
	else if(equali(sState, tag_stats[BYSTEAM]))
	{
		user_connected = is_user_exists_bysteam(sID)
	}
	else if(equali(sState, tag_stats[BYNAME]))
	{
		user_connected = is_user_exists_byname(sID)
	}
	else if(equali(sState, tag_stats[BYFLAG]))
	{
		user_connected ++
	}
	else if(equali(sState, tag_stats[BYPASS]))
	{
		user_connected = is_user_exists_byip(sID)
		
		if(!user_connected)
		{
			user_connected = is_user_exists_bysteam(sID)
			
			if(!user_connected)
			{
				user_connected = is_user_exists_byname(sID)
			}
		}
	}
	
	if(!user_connected)
	{
		console_print(id, "User With This Stats Not Connected")
		return 1
	}
	
	static sFile[64], sBuffer[128]
	get_configsdir(sFile, charsmax(sFile))
	formatex(sFile, charsmax(sFile), "%s/%s", sFile, TAG_FILE_NAME)
	
	if(!file_exists(sFile))
	{
		log_error(AMX_ERR_NOTFOUND, "File %s is Not Exist", TAG_FILE_NAME)
		return 1
	}
	
	if(equali(sState, tag_stats[BYPASS]))
	{
		if(!strlen(sPass))
		{
			console_print(id, "Please enter user password!")
			return 1
		}
		
		formatex(sBuffer, charsmax(sBuffer), "^n^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^"", sState, sID, zFlag, sTag, sCColor, sPass)
	}
	else
	{
		formatex(sBuffer, charsmax(sBuffer), "^n^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^"", sState, sID, zFlag, sTag, sCColor)
	}
	
	write_file(sFile, sBuffer)
	
	log_amx("Tag With This Data Has Been Successful added :-%s", sBuffer)
	console_print(id, "Tag With This Data Has Been Successful added :-%s", sBuffer)
	
	remove_tag(user_connected)
	check_user_tag(user_connected)
	return 1
}

public cmd_remove_tagmenu(id, level, cid)
{
	if(!cmd_access(id, level, cid, 1))
		return 1
	
	remove_tags_menu(id)
	return 1
}

public cmd_change_tagmenu(id, level, cid)
{
	if(!cmd_access(id, level, cid, 1))
		return 1
	
	multitag_menu(id)
	return 1
}

public remove_tags_menu(id)
{
	new szSnum[5], sBuffer[192], num
	
	formatex(sBuffer, charsmax(sBuffer), "\rRemove \wTags\r!")
	new tag_menu = menu_create(sBuffer, "remove_tags_menu_handle")
	
	static sFile[64]
	
	get_configsdir(sFile, charsmax(sFile))
	formatex(sFile, charsmax(sFile), "%s/%s", sFile, TAG_FILE_NAME)
	new fp = fopen(sFile, "rt")
	
	if(!fp)
	{
		log_error(AMX_ERR_NOTFOUND, "File %s is Not Exist", TAG_FILE_NAME)
		return
	}
	
	while(!feof(fp))
	{
		fgets(fp, sBuffer, charsmax(sBuffer))
		
		trim(sBuffer)
		
		if(strlen(sBuffer) < 5 || sBuffer[0] == ';' || (sBuffer[0] == '/' && sBuffer[1] == '/')) continue;
		
		num++
		formatex(szSnum, charsmax(szSnum), "%d", num)
		menu_additem(tag_menu, sBuffer, szSnum)
	}
	fclose(fp)
	
	menu_display(id, tag_menu)
}

public remove_tags_menu_handle(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return 1
	}
	
	new sBuffer[192], sAccess, sCallback, x
	menu_item_getinfo(menu, item, sAccess, "", 0, sBuffer, charsmax(sBuffer), sCallback)
	
	static sFile[64]
	new xBuffer[192], zBuff[192]
	
	get_configsdir(sFile, charsmax(sFile))
	formatex(sFile, charsmax(sFile), "%s/%s", sFile, TAG_FILE_NAME)
	new fp = fopen(sFile, "rt")
	
	if(!fp)
	{
		log_error(AMX_ERR_NOTFOUND, "File %s is Not Exist", TAG_FILE_NAME)
		return -1
	}
	
	log_amx("Tag With this Stats - %s - Has Successful been Removed!", sBuffer)
	console_print(id, "Tag With this Stats %s - Has Successful been Removed!", sBuffer)
	client_print(id, print_chat, "Tag With this Stats %s - Has Successful been Removed!", sBuffer)
	
	while(!feof(fp))
	{
		x++
		
		fgets(fp, xBuffer, charsmax(xBuffer))
		
		trim(xBuffer)
		
		if(strlen(xBuffer) < 5 || xBuffer[0] == ';' || (xBuffer[0] == '/' && xBuffer[1] == '/')) continue;
		
		if(equali(xBuffer, sBuffer))
		{
			x --
			formatex(zBuff, charsmax(zBuff), "; %s", sBuffer);
			write_file(sFile, zBuff, x);
			break;
		}
	}
	fclose(fp)
	
	remove_users_tags()
	tag_file()
	
	return 0
}

public user_pass_tag_menu(id)
{
	if(is_user_tag_exists(id, clogintag[id]) > -1)
	{
		console_print(id, "[ TAG ] you don't have other tags to activate by pass!")
		return
	}
	
	new i = strlen(clogintag[id])-2;
	
	if(i < 1)
		return;
	
	new UPMenu, sText[164], sLogin_Info[16], sPassword[32], sTag[34];
	
	formatex(sTag, charsmax(sTag), clogintag[id])
	replace_all(sTag, charsmax(sTag), "!g", "\y")
	replace_all(sTag, charsmax(sTag), "!y", "\w")
	replace_all(sTag, charsmax(sTag), "!t", "\r")
	
	formatex(sText, charsmax(sText), "\yPlease enter you'r \rpassword...^n\yLogin-Tag: \r%s (CChat)", sTag)
	UPMenu = menu_create(sText, "user_pass_tag_menu_handle")
	
	get_pcvar_string(g_cvar_pw, sLogin_Info, charsmax(sLogin_Info))
	get_user_info(id, sLogin_Info, sPassword, charsmax(sPassword))
	
	if(!user_show_password[id]) {
	for(new i = 0; i < strlen(sPassword); i++)
	{
		sPassword[i] = '*'
	} }
	
	formatex(sText, charsmax(sText), "Password : \r%s", sPassword)
	menu_additem(UPMenu, sText, "1", 0)
	
	formatex(sText, charsmax(sText), "Show Password : %s", user_show_password[id] ? "\rYes":"\wNo")
	menu_additem(UPMenu, sText, "2", 0)
	
	menu_addtext(UPMenu, "^n^n^n", 0)
	
	formatex(sText, charsmax(sText), "%s", (strlen(sPassword)) ? "\yLogin":"\dLogin")
	menu_additem(UPMenu, sText, "3", 0)
	
	menu_display(id, UPMenu)
}

public user_pass_tag_menu_handle(id, Menu, Item)
{
	if(Item == MENU_EXIT)
	{
		menu_destroy(Menu)
		return
	}
	
	new sData[2], sName[64]
	new sAccess, sCallback
	menu_item_getinfo(Menu, Item, sAccess, sData, charsmax(sData), sName, charsmax(sName), sCallback)
	
	switch( sData[0] )
	{
		case '1':
		{
			client_cmd(id, "messagemode amx_tag_password")
			return
		}
		case '2':
		{
			if(!user_show_password[id])
			{
				user_show_password[id] = true
			}
			else if(user_show_password[id])
			{
				user_show_password[id] = false
			}
		}
		case '3':
		{
			if(equal(sName, "\d", 2))
			{
				client_print(id, print_center, "please enter the password to login!")
			}
			else
			{
				switch( check_user_password(id) )
				{
					case 1:
					{
						client_print(id, print_center, "Incorrect Password!")
					}
					case 2:
					{
						client_print(id, print_center, "Login Successful!")
						return
					}
					default:
					{
						return
					}
				}
			}
		}
	}
	
	user_pass_tag_menu(id)
}

public check_user_password(id)
{
	static sFile[64], sBuffer[128], sParam[5][34], sCColor[4]
	
	new user_ipa[32], user_steamid[32], user_info[32], login_info[16], j, Atlast, user_name[32];
	
	get_user_ip(id, user_ipa, charsmax(user_ipa), 1)
	get_user_authid(id, user_steamid, charsmax(user_steamid))
	get_user_name(id, user_name, charsmax(user_name))
	get_pcvar_string(g_cvar_pw, login_info, charsmax(login_info))
	get_user_info(id, login_info, user_info, charsmax(user_info))
	
	get_configsdir(sFile, charsmax(sFile))
	formatex(sFile, charsmax(sFile), "%s/%s", sFile, TAG_FILE_NAME)
	new fp = fopen(sFile, "rt")
	
	if(!fp)
	{
		log_error(AMX_ERR_NOTFOUND, "File %s is Not Exist", TAG_FILE_NAME)
		return -1
	}
	
	while(!feof(fp))
	{
		fgets(fp, sBuffer, charsmax(sBuffer))
		
		if(strlen(sBuffer) < 5 || sBuffer[0] == ';' || (sBuffer[0] == '/' && sBuffer[1] == '/')) continue;
		
		parse(sBuffer, sParam[0], charsmax(sParam[]), sParam[1], charsmax(sParam[]), sParam[2], charsmax(sParam[]), sParam[3], charsmax(sParam[]), sCColor, charsmax(sCColor), sParam[4], charsmax(sParam[]))
		
		for(j = 0; j < sizeof sParam; j++)
		{
			remove_quotes(sParam[j])
		}
		
		remove_quotes(sCColor)
		trim(sCColor)
		add(sParam[3], charsmax(sParam[]), sCColor)
		
		if(equali(sParam[0], tag_stats[BYPASS]))
		{
			if((equali(sParam[1], user_ipa) || equali(sParam[1], user_steamid) || equali(sParam[1], user_name))
			&& get_user_flags(id) & read_flags((sParam[2])))
			{
				if(is_user_tag_exists(id, sParam[3]) > -1)
				{
					continue;
				}
				else if(equali(sParam[4], user_info) && equali(sParam[3], clogintag[id]))
				{
					ArrayPushString(Multitag[id], sParam[3])
					
					if(!g_user_prefix[id])
					{
						formatex(user_prefix[id], charsmax(user_prefix[]), sParam[3])
					}
					g_user_prefix[id] ++
					log_amx("#%d %s Has Login With ^"%d^" Tags!", id, user_name, g_user_prefix[id])
					Atlast = 2
				}
				else if(!equali(sParam[4], user_info) && equali(sParam[3], clogintag[id]))
				{
					Atlast = 1
					break;
				}
				else if(!equali(sParam[3], clogintag[id]))
				{
					break;
				}
			}
		}
	}
	
	if(!task_exists(id+TASK_LOGIN_BYPASS) && Atlast == 2 && strlen(sParam[3]) >= 3 && equali(sParam[0], tag_stats[BYPASS]))
	{
		set_task(3.0, "Task_Login", id+TASK_LOGIN_BYPASS, sParam[3], charsmax(sParam[]), "b")
	}
	return Atlast
}

public user_entered_password(id)
{
	new sArgs[32], sLogin_Info[16]
	read_argv(1, sArgs, charsmax(sArgs))
	
	get_pcvar_string(g_cvar_pw, sLogin_Info, charsmax(sLogin_Info))
	set_user_info(id, sLogin_Info, sArgs)
	client_cmd(id, "setinfo ^"%s^" ^"%s^"", sLogin_Info, sArgs)
	
	user_pass_tag_menu(id)
}

public Task_Login(params[], Taskid)
{
	new id = Taskid - TASK_LOGIN_BYPASS
	
	if(!is_user_alive(id))
		return
	
	formatex(clogintag[id], charsmax(clogintag[]), "%s", params)
	user_pass_tag_menu(id)
	remove_task(Taskid)
}

public multitag_menu(id)
{
	new MTMenu, sText[128], i, sTag[34], sNum[2], bool:tag_chosen;
	
	formatex(sText, charsmax(sText), "\yChoose a \rtag !?")
	MTMenu = menu_create(sText, "multitag_menu_handle")
	
	for(i = 0; i < ArraySize(Multitag[id]); i++)
	{
		sNum[0] = i
		
		ArrayGetString(Multitag[id], i, sTag, charsmax(sTag))
		
		tag_chosen = equal(sTag, user_prefix[id]) ? true:false
		
		replace_all(sTag, charsmax(sTag), "!y", tag_chosen ? "^0":"\w")
		replace_all(sTag, charsmax(sTag), "!t", tag_chosen ? "^0":"\r")
		replace_all(sTag, charsmax(sTag), "!g", tag_chosen ? "^0":"\y")
		
		formatex(sText, charsmax(sText), "%s%s   (CColor)", tag_chosen ? "\d":"\y", sTag)
		menu_additem(MTMenu, sText, sNum[0], 0)
	}
	
	if(!i)
		return;
	if(!equal(user_prefix[id], "DISABLED254358"))
		menu_additem(MTMenu, "Disable the tag!", "D")
	
	menu_display(id, MTMenu)
}

public multitag_menu_handle(id, Menu, Item)
{
	if(Item == MENU_EXIT)
	{
		menu_destroy(Menu)
		return
	}
	
	new sData[2], sName[64], sTag[33]
	new sAccess, sCallback
	menu_item_getinfo(Menu, Item, sAccess, sData, charsmax(sData), sName, charsmax(sName), sCallback)
	
	if(sData[0] == 'D')
	{
		chat_message(MSG_ONE, id, id, "!g[ TAG ] !yThe tag has been disabled!t!")
		formatex(user_prefix[id], charsmax(user_prefix[]), "DISABLED254358")
		return;
	}
	
	ArrayGetString(Multitag[id], sData[0], sTag, charsmax(sTag))
	formatex(user_prefix[id], charsmax(user_prefix[]), sTag)
	
	save_user_last_tag(id)
	
	chat_message(MSG_ONE, id, id, "!g[ TAG ] !yYou have changed you'r tag to !g%s !t!", sTag)
}

public remove_tag(index)
{
	ArrayClear(Multitag[index])
	remove_task(index+TASK_LOGIN_BYPASS)
	formatex(user_prefix[index], charsmax(user_prefix[]), "^0")
	formatex(clogintag[index], charsmax(clogintag[]), "^0")
	g_user_prefix[index] = 0
	user_show_password[index] = false
}

public remove_users_tags()
{
	get_players(players, pnum, "ch")
	
	for(new p = 0; p < pnum; p++)
	{
		if(!is_user_connected(players[p]))
			continue;
		
		remove_tag(players[p])
	}
}

public tag_file()
{
	static sFile[64], sBuffer[128], sParam[4][34]
	
	new find_user
	
	get_configsdir(sFile, charsmax(sFile))
	formatex(sFile, charsmax(sFile), "%s/%s", sFile, TAG_FILE_NAME)
	new fp = fopen(sFile, "rt")
	
	if(!fp)
	{
		log_error(AMX_ERR_NOTFOUND, "File %s is Not Exist", TAG_FILE_NAME)
		return
	}
	
	while(!feof(fp))
	{
		fgets(fp, sBuffer, charsmax(sBuffer))
		
		trim(sBuffer)
		
		if(strlen(sBuffer) < 5 || sBuffer[0] == ';' || (sBuffer[0] == '/' && sBuffer[1] == '/')) continue;
		
		parse(sBuffer, sParam[0], charsmax(sParam[]), sParam[1], charsmax(sParam[]), sParam[2], charsmax(sParam[]), sParam[3], charsmax(sParam[]))
		
		for(new j = 0; j < sizeof sParam; j++)
		{
			remove_quotes(sParam[j])
		}
		
		if(equali(sParam[0], tag_stats[BYFLAG]))
		{
			get_players(players, pnum, "ch")
			
			for(new v = 0; v < pnum; v++)
			{
				check_user_tag(players[v])
			}
		}
		else
		{
			find_user = is_user_exists_byip(sParam[1])
			
			if(!find_user)
			{
				find_user = is_user_exists_byname(sParam[1])
				
				if(!find_user)
				{
					find_user = is_user_exists_bysteam(sParam[1])
					
					if(!find_user)
					{
						continue;
					}
				}
			}
			
			check_user_tag(find_user)
		}
	}
	fclose(fp)
}

public check_user_tag(id)
{
	static sFile[64], sBuffer[128], sParam[5][34], sCColor[4];
	
	new user_ipa[32], user_steamid[32], user_info[32], login_info[16], uGot_tag = g_user_prefix[id], user_name[32];
	
	get_user_ip(id, user_ipa, charsmax(user_ipa), 1)
	get_user_authid(id, user_steamid, charsmax(user_steamid))
	get_user_name(id, user_name, charsmax(user_name))
	get_pcvar_string(g_cvar_pw, login_info, charsmax(login_info))
	get_user_info(id, login_info, user_info, charsmax(user_info))
	
	get_configsdir(sFile, charsmax(sFile))
	formatex(sFile, charsmax(sFile), "%s/%s", sFile, TAG_FILE_NAME)
	new fp = fopen(sFile, "rt")
	
	if(!fp || !file_exists(sFile))
	{
		log_error(AMX_ERR_NOTFOUND, "File %s is Not Exist", TAG_FILE_NAME)
		return -1
	}
	
	while(!feof(fp))
	{
		fgets(fp, sBuffer, charsmax(sBuffer))
		
		trim(sBuffer)
		
		if(strlen(sBuffer) < 5 || sBuffer[0] == ';' || (sBuffer[0] == '/' && sBuffer[1] == '/')) continue;
		
		parse(sBuffer, sParam[0], charsmax(sParam[]), sParam[1], charsmax(sParam[]), sParam[2], charsmax(sParam[]), sParam[3], charsmax(sParam[]), sCColor, charsmax(sCColor), sParam[4], charsmax(sParam[]))
		
		for(new j = 0; j < sizeof sParam; j++)
		{
			remove_quotes(sParam[j])
		}
		
		remove_quotes(sCColor)
		trim(sCColor)
		add(sParam[3], charsmax(sParam[]), sCColor)
		
		if(equali(sParam[0], tag_stats[BYPASS]))
		{
			if((equali(sParam[1], user_ipa) || equali(sParam[1], user_steamid) || equali(sParam[1], user_name))
			&& get_user_flags(id) & read_flags(sParam[2]))
			{
				if(is_user_tag_exists(id, sParam[3]) > -1)
				{
					continue;
				}
				else if(equali(sParam[4], user_info))
				{
					ArrayPushString(Multitag[id], sParam[3])
					
					if(!g_user_prefix[id])
					{
						formatex(user_prefix[id], charsmax(user_prefix[]), sParam[3])
					}
					g_user_prefix[id] ++
				}
				else if(!task_exists(id+TASK_LOGIN_BYPASS))
				{
					set_task(3.0, "Task_Login", id+TASK_LOGIN_BYPASS, sParam[3], charsmax(sParam[]), "b")
					continue;
				}
			}
		}
		else if(equali(sParam[0], tag_stats[BYIP]))
		{
			if(is_user_tag_exists(id, sParam[3]) > -1)
			{
				continue;
			}
			else if(equali(sParam[1], user_ipa) && get_user_flags(id) & read_flags(sParam[2]))
			{
				ArrayPushString(Multitag[id], sParam[3])
				
				if(!g_user_prefix[id])
				{
					formatex(user_prefix[id], charsmax(user_prefix[]), sParam[3])
				}
				g_user_prefix[id] ++
			}
		}
		else if(equali(sParam[0], tag_stats[BYSTEAM]))
		{
			if(is_user_tag_exists(id, sParam[3]) > -1)
			{
				continue;
			}
			else if(equali(sParam[1], user_steamid) && get_user_flags(id) & read_flags(sParam[2]))
			{
				ArrayPushString(Multitag[id], sParam[3])
				
				if(!g_user_prefix[id])
				{
					formatex(user_prefix[id], charsmax(user_prefix[]), sParam[3])
				}
				g_user_prefix[id] ++
			}
		}
		else if(equali(sParam[0], tag_stats[BYNAME]))
		{
			if(is_user_tag_exists(id, sParam[3]) > -1)
			{
				continue;
			}
			else if(equali(sParam[1], user_name) && get_user_flags(id) & read_flags(sParam[2]))
			{
				ArrayPushString(Multitag[id], sParam[3])
				
				if(!g_user_prefix[id])
				{
					formatex(user_prefix[id], charsmax(user_prefix[]), sParam[3])
				}
				g_user_prefix[id] ++
			}
		}
		else if(equali(sParam[0], tag_stats[BYFLAG]))
		{
			if(is_user_tag_exists(id, sParam[3]) > -1)
			{
				continue;
			}
			else if(get_user_flags(id) & read_flags(sParam[2]))
			{
				ArrayPushString(Multitag[id], sParam[3])
				
				if(!g_user_prefix[id])
				{
					formatex(user_prefix[id], charsmax(user_prefix[]), sParam[3])
				}
				
				g_user_prefix[id] ++
			}
		}
	}
	fclose(fp)
	
	if(uGot_tag < g_user_prefix[id])
	{
		new sTag[34]
		if(load_user_last_tag(id, sTag, charsmax(sTag)))
		{
			if(is_user_tag_exists(id, sTag) > -1)
			{
				formatex(user_prefix[id], charsmax(user_prefix[]), sTag)
			}
		}
		
		log_amx("#%d %s Has Login With ^"%d^" Tags!", id, user_name, g_user_prefix[id])
	}
	return 0
}

stock is_user_exists_byip(const ip[])
{
	new ipa[32]
	
	get_players(players, pnum, "ch")
	
	for(new i = 0; i < pnum; i++)
	{
		if(is_user_connected(players[i]))
		{
			get_user_ip(players[i], ipa, charsmax(ipa), 1)
			
			if(equal(ipa, ip))
			{
				return players[i]
			}
		}
	}
	
	return 0
}

stock is_user_exists_bysteam(const steamid[])
{
	new steam[32]
	
	get_players(players, pnum, "ch")
	
	for(new i = 0; i < pnum; i++)
	{
		if(is_user_connected(players[i]))
		{
			get_user_authid(players[i], steam, charsmax(steam))
			
			if(equal(steam, steamid))
			{
				return players[i]
			}
		}
	}
	
	return 0
}

stock is_user_exists_byname(const name[])
{
	new user_name[32]
	
	get_players(players, pnum, "ch")
	
	for(new i = 0; i < pnum; i++)
	{
		if(is_user_connected(players[i]))
		{
			get_user_name(players[i], user_name, charsmax(user_name))
			
			if(equal(user_name, name))
			{
				return players[i]
			}
		}
	}
	
	return 0
}

stock is_user_tag_exists(id, const tag[])
{
	new z, sTag[33]
	
	for(z = 0; z < ArraySize(Multitag[id]); z++)
	{
		ArrayGetString(Multitag[id], z, sTag, charsmax(sTag))
		
		if(equal(tag, sTag))
		{
			return z;
		}
	}
	
	return -1;
}

stock chat_message(dest, player, index, const message[], any:...)
{
	new sBuffer[256]
	vformat(sBuffer[1], charsmax(sBuffer), message, 5)
	
	sBuffer[0] = '^1'
	
	replace_all(sBuffer[1], charsmax(sBuffer), "!y", "^1")
	replace_all(sBuffer[1], charsmax(sBuffer), "!t", "^3")
	replace_all(sBuffer[1], charsmax(sBuffer), "!g", "^4")
	
	sBuffer[192] = '^0'
	
	message_begin(dest, get_user_msgid("SayText"), {0, 0, 0}, player)
	write_byte(index)
	write_string(sBuffer)
	message_end()
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ fbidis\\ ansi\\ ansicpg1252\\ deff0{\\ fonttbl{\\ f0\\ fnil\\ fcharset0 Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ ltrpar\\ lang2057\\ f0\\ fs16 \n\\ par }
*/
